	include	"doorsos.h"			; general ROM calls
	include	"graphlib.h"			; clr_scr function
	include "userlib.h"			; idle_loop function
	include "hexlib.h"			; put_hex function

	xdef	_ti89				; make TI-89 program
	xdef	_main				; define program entry point
	xdef	_comment			; define comment

_main:
	movea.l	a7,a6
\home:
	jsr	graphlib::clr_scr		; clear plane0

	WriteStr	#0,#0,#1,fractext

	move.l	#0,d5				; d5=type

	WriteStr	#0,#10,#4,cfttext
	WriteStr	#0,#20,#4,fractypetext

	bsr	_fracedit			; choose fractal type

	tst.l	d1				; was esc pressed?
	blt	\error

	move.b	d5,(frac)

	move.l	#-$02800000,(xmin)		;mandel coors
	move.l	#$01500000,(ymax)
	move.l	#$00067B1C,(dx)
	move.l	#$0006DBA5,(dy)
	move.b	#24,(kinit)

	tst.b	(frac)
	bgt	\man1				; if mandel no param setup

	move.l	#-$02000000,(xmin)		;julia coords
	move.l	#$01800000,(ymax)
	move.l	#$00067B1C,(dx)
	move.l	#$0007D630,(dy)

	move.l	#$004CCCCC,(cr)
	move.l	#$00999999,(ci)			; c=c1,c2

	WriteStr	#0,#30,#1,paramtext

	WriteStr	#0,#40,#4,crtext

	move.l	#$00100000,d6			; d6=delta
	move.l	#2,d5				; d5=digit

	move.l	(cr),d0
	move.l	#5,d1
	move.l	#5,d2

	bsr	_paramedit			; edit real param

	tst.l	d1				; was esc pressed?
	blt	\error

	move.l	d0,(cr)

	WriteStr	#0,#48,#4,citext

	move.l	(ci),d0
	move.l	#6,d1
	move.l	#5,d2

	bsr	_paramedit			; edit imag param

	tst.l	d1				; was esc pressed?
	blt	\error

	move.l	d0,(ci)

\man1:

	jsr	graphlib::gray7
	tst.l	d0
	beq	\error

\redraw:
	move.l	(graphlib::plane0),a0		; put screen memory
	move.l	(graphlib::plane1),a1		; put screen memory
	move.l	(graphlib::plane2),a2		; put screen memory

	move.w	#959,d0				; clear planes
\clrloop:
	clr.l	(a0)+
	clr.l	(a1)+
	clr.l	(a2)+
	dbra.w	d0,\clrloop

	move.l	(graphlib::plane0),a0		; put screen memory
	move.l	(graphlib::plane1),a1		; put screen memory
	move.l	(graphlib::plane2),a2		; put screen memory

	move.b	#100,(rowcounter)
	move.b	#19,(linecounter)
	move.b	#7,(bytecounter)

	move.l	(xmin),(x)
	move.l	(ymax),(y)			; x=xmin,y=ymax

\a:
	tst.b	(frac)
	beq	\jul1
	moveq.l	#0,d6				; zr=0 (mandel stuff)
	moveq.l	#0,d7				; zi=0
	move.l	(x),(cr)
	move.l	(y),(ci)
	bra	\man2

\jul1:
	move.l	(x),d6				; zr=x (julia stuff)
	move.l	(y),d7				; zi=y

\man2:
	move.b	(kinit),(k)			; k=kinit

\b:
	move.l	d7,d0				; begin zi^2
	move.l	d7,d1

	bsr	_mul32				; end zi^2

	move.l	d0,d5				; d2=zi^2

	move.l	d6,d0				; begin zr^2
	move.l	d6,d1

	bsr	_mul32				; end zr^2

	move.l	d6,d1
	move.l	d0,d6				; d6=zr^2
	move.l	d7,d0				; begin zr*zi*2

	bsr	_mul32

	asl.l	#1,d0				; d0=zr*zi*2

	move.l	d0,d7				; begin zr^2-zi^2,zr*zi*2
	move.l	d6,d1
	sub.l	d5,d6				; end zr^2-zi^2,zr*zi*2

	add.l	d1,d5				; begin zr^2+zi^2 > 4?
	cmpi.l	#$04000000,d5			; end zr^2+zi^2 > 4?
	bgt	\d

	add.l	(cr),d6				; begin z=z^2+c
	add.l	(ci),d7

	subq.b	#1,(k)
	bge	\b				; k=k-1, if k>=0 goto b

\d:
	move.l	(dx),d0
	add.l	d0,(x)				; x=x+dx

	move.b	(bytecounter),d0 
	btst.b	#0,(k)				; plane0
	bne	\odd
	bset.b	d0,(a0)				; set pixel
\odd:
	btst.b	#1,(k)				; plane1
	bne	\odd2
	bset.b	d0,(a1)				; set pixel
\odd2:
	btst.b	#2,(k)				; plane2
	bne	\odd3
	bset.b	d0,(a2)				; set pixel
\odd3:
	subq.b	#1,(bytecounter)		; next pixel
	bge	\a
	move.b	#7,(bytecounter)

	addq.l	#1,a0				; next byte
	addq.l	#1,a1				; next byte
	addq.l	#1,a2				; next byte

	subq.b  #1,(linecounter)		; decrease linecounter
	bge	\a				; end of row?

	move.l	(dy),d0
	sub.l	d0,(y)				; decrease y
	move.l	(xmin),(x)			; x=xmin

	move.b	#19,(linecounter)

	adda.l	#10,a0				; next row
	adda.l	#10,a1				; next row
	adda.l	#10,a2				; next row

	subq.b	#1,(rowcounter)			; decrease rowcount

	tst.w	(doorsos::kb_vars+$1C)
	bne	\halt

	tst.b	(rowcounter)			; decrease rowcount
	bgt 	\a				; last pixel?

\halt:
	clr.w	(doorsos::kb_vars+$1C)

	move.l #60,d0
	move.l #37,d1
	move.l #40,d2
	move.l #25,d3
	move.l #0,d4


\idleloop2:					; start zoom routine					; wait for user to press a key
	tst.w	(doorsos::kb_vars+$1C)
	beq	\idleloop2

\keyloop:					; start zoom routine					; wait for user to press a key
	jsr	graphlib::fill

\idleloop:					; wait for user to press another key
	tst.w	(doorsos::kb_vars+$1C)
	beq	\idleloop
	move.w	(doorsos::kb_vars+$1E),d5
	clr.w	(doorsos::kb_vars+$1C)

	jsr	graphlib::fill

	cmp.w	#264,d5				; esc pressed ?
	beq	\esc

	cmp.w	#277,d5				; home pressed ?
	bne	\nohome
	jsr	graphlib::gray2
	bra	\home

\nohome:
	cmp.w	#263,d5				; clear pressed ?
	bne	\noclear
	tst.b	(rowcounter)			; drawing complete ?
	bgt 	\a				; continue drawing ?	
	bra	\redraw				; else redraw
\noclear:

	cmp.w	#13,d5
	beq	\zoom

	move.b 	#%11111110,($600019)  		;set the row with arrow keys in it

	cmp.w	#266,d5
	bne	\nocycle
	move.l	d0,-(a7)
	move.l	d1,-(a7)
	move.l	d2,-(a7)
	move.l	a0,-(a7)
	move.l	a1,-(a7)
	move.l	a2,-(a7)

	bsr	_palcycle

	move.l	(a7)+,a2
	move.l	(a7)+,a1
	move.l	(a7)+,a0
	move.l	(a7)+,d2
	move.l	(a7)+,d1
	move.l	(a7)+,d0
	bra	\idleloop2

\nocycle:
	move.b ($60001b),d5          		;read back keypress data

	btst.b 	#0,d5
	bne	\not_up
	cmpi.w	#0,d1
	ble	\not_up
	subq.w	#1,d1

\not_up:
	btst.b 	#2,d5
	bne	\not_down
	cmpi.w	#74,d1
	bge	\not_down
	addq.w	#1,d1

\not_down:
	btst.b 	#1,d5
	bne	\not_left
	cmpi.w	#0,d0
	ble	\not_left
	subq.w	#1,d0

\not_left:
	btst.b 	#3,d5
	bne	\not_right
	cmpi.w	#119,d0
	bge	\not_right
	addq.w	#1,d0

\not_right:
	bra	\keyloop

\zoom:
	ror.l	#8,d0
	ror.l	#8,d1

	move.l	d1,d5

	move.l	(dx),d1

	jsr	_mul32

	add.l	d0,(xmin)			; x=xmin+dx*zoompos(x)

	move.l	d5,d0
	move.l	(dy),d1

	jsr	_mul32

	sub.l	d0,(ymax)			; y=ymax-dy*zoompos(y)

	move.l	(dx),d0
	asr.l	#2,d0
	move.l	d0,(dx)				; dx=dx/4

	move.l	(dy),d0
	asr.l	#2,d0
	move.l	d0,(dy)				; dy=dy/4

	cmpi.b	#120,(kinit)
	bge	\kmax
	addi.b	#8,(kinit)			; we dont wanna lose detail

\kmax:	
	bra	\redraw

\esc:
	jsr	graphlib::gray2

\error:
	movea.l	a6,a7

	rts					; exit program



; 32bit fixpoint multiplication - 8bit intpart, 24bit fracpart

_mul32:
	moveq.l	#1,d4

	tst.l	d0
	bge	\pos1
	neg.l	d0
	neg.l	d4
\pos1:

	tst.l	d1
	bge	\pos2
	neg.l	d1
	neg.l	d4
\pos2:
	move.l	d0,d2

	mulu.w	d1,d0				; d0 frac*d1 frac
	rol.l	#8,d0
	clr.l	d3				; 8 bits
	move.b	d0,d3

	swap	d1
	move.l	d2,d0
	mulu.w	d1,d0				; d0 frac*d1 int
	lsr.l	#8,d0
	add.l	d0,d3

	swap	d2	
	move.l	d2,d0
	mulu.w	d1,d0				; d0 int*d1 int
	lsl.l	#8,d0
	add.l	d0,d3

	swap	d1
	move.l	d2,d0	
	mulu.w	d1,d0				; d0 int*d1 frac
	lsr.l	#8,d0
	add.l	d3,d0

	tst.l	d4
	bgt	\pos3
	neg.l	d0
\pos3:
	rts


_paramedit:
	move.l	#7,d4				; put 8 digits

	jsr	hexlib::put_hex
	subi.l	#8,d2
	
	move.l	d0,-(a7)
	move.l	d1,-(a7)
	move.l	d2,-(a7)

	move.l	#8,d0				; 8*selected digit
	mulu.w	d5,d0

	mulu.w	#8,d2				; add 8*text column
	add.l	d2,d0

	mulu.w	#8,d1				; 8*text row

	move.l	#6,d2				; size 6*6
	move.l	#6,d3
	move.l	#0,d4				; color invert

	jsr	graphlib::fill			; invert digit

	move.l	(a7)+,d2
	move.l	(a7)+,d1
	move.l	(a7)+,d0

	move.b #%11111110,($600019)  		;set the row with arrow keys in it

\idle:
	tst.w	(doorsos::kb_vars+$1C)
	beq	\idle
	move.w	(doorsos::kb_vars+$1E),d7	; d7=key
	clr.w	(doorsos::kb_vars+$1C)

	cmp.w	#13,d7
	beq	\paramdone

	cmp.w	#264,d7
	beq	\paramesc

	move.b ($60001b),d7          		;read back keypress data

	btst.b #0,d7
	bne	\not_add
	add.l	d6,d0

\not_add:
	btst.b #2,d7
	bne	\not_sub
	sub.l	d6,d0

\not_sub:
	btst.b #1,d7
	bne	\not_rol
	rol.l	#4,d6
	sub.l	#1,d5
	bge	\not_rol
	move.l	#7,d5

\not_rol:
	btst.b #3,d7
	bne	\not_ror
	ror.l	#4,d6
	add.l	#1,d5
	cmp.l	#7,d5
	ble	\not_ror
	move.l	#0,d5

\not_ror:
	bra	_paramedit

\paramesc:
	move.l	#-1,d1

\paramdone:
	rts




_fracedit:	
	move.l	#60,d0				; 8*selected digit
	mulu.w	d5,d0

	move.l	#19,d1				; 8*selected digit

	move.l	#59,d2				; size 40*6
	move.l	#9,d3
	move.l	#0,d4				; color invert

	jsr	graphlib::fill			; invert digit

	move.b #%11111110,($600019)  		;set the row with arrow keys in it

\idlefe:
	tst.w	(doorsos::kb_vars+$1C)
	beq	\idlefe
	move.w	(doorsos::kb_vars+$1E),d7	; d7=key
	clr.w	(doorsos::kb_vars+$1C)

	cmp.w	#13,d7
	beq	\fracdone

	cmp.w	#264,d7
	beq	\fracesc

	jsr	graphlib::fill			; invert digit

	move.b ($60001b),d7          		;read back keypress data

	btst.b #1,d7
	bne	\not_rol2
	sub.l	#1,d5
	bge	\not_rol2
	move.l	#1,d5

\not_rol2:
	btst.b #3,d7
	bne	\not_ror2
	add.l	#1,d5
	cmp.l	#1,d5
	ble	\not_ror2
	move.l	#0,d5

\not_ror2:
	bra	_fracedit

\fracesc:
	move.l	#-1,d1

\fracdone:
	rts




_palcycle:
	move.l	(graphlib::plane0),a0		; put screen memory
	move.l	(graphlib::plane1),a1		; put screen memory
	move.l	(graphlib::plane2),a2		; put screen memory

	move.b	#100,d1
	move.b	#19,d2
	move.b	#7,d0

\cycle:
	btst.b	d0,(a0)				; plane0
	bne	\oddc
	bset.b	d0,(a0)				; set pixel
	bra	\nextpix

\oddc:
	bclr.b	d0,(a0)				; clr pixel
	btst.b	d0,(a1)				; plane1
	bne	\oddc2
	bset.b	d0,(a1)				; set pixel
	bra	\nextpix

\oddc2:
	bclr.b	d0,(a1)				; clr pixel
	btst.b	d0,(a2)				; plane2
	bne	\oddc3
	bset.b	d0,(a2)				; set pixel
	bra	\nextpix

\oddc3:
	bclr.b	d0,(a2)				; clr pixel

\nextpix:
	subq.b	#1,d0				; next pixel
	bge	\cycle
	move.b	#7,d0

	addq.l	#1,a0				; next byte
	addq.l	#1,a1				; next byte
	addq.l	#1,a2				; next byte

	subq.b  #1,d2				; decrease linecounter
	bge	\cycle				; end of row?

	move.b	#19,d2

	adda.l	#10,a0				; next row
	adda.l	#10,a1				; next row
	adda.l	#10,a2				; next row

	subq.b	#1,d1				; decrease rowcount
	cmp.b	(rowcounter),d1
	bgt 	\cycle				; last pixel?

	tst.w	(doorsos::kb_vars+$1C)
	bne	\haltcyc

	bra	_palcycle

\haltcyc:
	clr.w	(doorsos::kb_vars+$1C)
	rts

_comment	dc.b	"Fractal Explorer",0

rowcounter	dc.b	0
linecounter	dc.b	0
bytecounter	dc.b	0
k		dc.b	0
x		dc.l	0
y		dc.l	0
kinit		dc.b	0
xmin		dc.l	0
ymax		dc.l	0
dx		dc.l	0
dy		dc.l	0
cr		dc.l	0
ci		dc.l	0
frac		dc.b	0	; 1=mandel 0=julia

cfttext		dc.b	"Choose fractal type",0
fractypetext	dc.b	"Julia     Mandelbrot",0
fractext	dc.b	"Fractal Explorer 1.0 by WZ",0
paramtext	dc.b	"Parameter Setup",0
crtext		dc.b	"Creal:",0
citext		dc.b	"Cimag:",0

	end					; end of source code













